VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7065
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8580
   LinkTopic       =   "Form1"
   ScaleHeight     =   7065
   ScaleWidth      =   8580
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdGoto 
      Caption         =   "Goto Item"
      Height          =   375
      Left            =   7020
      TabIndex        =   14
      Top             =   4440
      Width           =   1335
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear List"
      Height          =   375
      Left            =   7020
      TabIndex        =   13
      Top             =   4080
      Width           =   1335
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove Item"
      Height          =   375
      Left            =   7140
      TabIndex        =   10
      Top             =   1320
      Width           =   1155
   End
   Begin VB.CommandButton cmdChangeItem 
      Caption         =   "Change Item"
      Height          =   375
      Left            =   7140
      TabIndex        =   9
      Top             =   960
      Width           =   1155
   End
   Begin VB.CommandButton cmdAddThousend 
      Caption         =   "Add 1000"
      Height          =   375
      Left            =   7140
      TabIndex        =   11
      Top             =   600
      Width           =   1155
   End
   Begin VB.Frame Frame2 
      Caption         =   "Sorting:"
      Height          =   1335
      Left            =   6960
      TabIndex        =   5
      Top             =   2040
      Width           =   1455
      Begin VB.CheckBox chkAscSort 
         Caption         =   "Ascending"
         Height          =   315
         Left            =   180
         TabIndex        =   8
         Top             =   960
         Value           =   1  'Aktiviert
         Width           =   1095
      End
      Begin VB.CommandButton cmdSortText 
         Caption         =   "Sort by Text"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   600
         Width           =   1155
      End
      Begin VB.CommandButton cmdSortTag 
         Caption         =   "Sort by Tag"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   1155
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Currently Selected:"
      Height          =   975
      Left            =   180
      TabIndex        =   3
      Top             =   6000
      Width           =   5775
      Begin VB.Label lblSelected 
         Height          =   615
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   5535
      End
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add Item"
      Height          =   375
      Left            =   7140
      TabIndex        =   2
      Top             =   240
      Width           =   1155
   End
   Begin VB.CheckBox chkBackground 
      Caption         =   "Background"
      Height          =   195
      Left            =   7020
      TabIndex        =   1
      Top             =   3540
      Width           =   1335
   End
   Begin VB.PictureBox picListbox 
      BackColor       =   &H80000005&
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5655
      Left            =   120
      ScaleHeight     =   5595
      ScaleWidth      =   6675
      TabIndex        =   0
      Top             =   240
      Width           =   6735
   End
   Begin VB.Label lblTotal 
      Caption         =   "Total Items:"
      Height          =   555
      Left            =   6120
      TabIndex        =   12
      Top             =   6120
      Width           =   1875
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTickCount Lib "kernel32.dll" () As Long


Dim oColorList As clsColoredListbox

Private Sub chkBackground_Click()
   If chkBackground.Value = vbChecked Then
      picListbox.Picture = LoadPicture("back.jpg")
      oColorList.Connect picListbox, LoadPicture("highlight.jpg")
   Else
      picListbox.Picture = LoadPicture()
      oColorList.Connect picListbox
   End If
End Sub


Private Sub cmdAdd_Click()
      oColorList.AddItem "\ff0000\Hello \00ff00\colored \0000ff\World ! " & _
                                "\ff00ff\Hello \00ffff\colored \ffff00\World ! " & _
                                "\ff00ff\Hello \00ffff\colored \ffff00\World ! ", Now
   UpdateInfo
End Sub

Private Sub cmdAddThousend_Click()
   Dim x As Integer
   For x = 0 To 998 Step 2
      oColorList.AddItem Chr(x Mod 26 + 65) & " \ff0000\Hello \00ff00\colored \0000ff\World ! " & _
                                "\ff00ff\Hello \00ffff\colored \ffff00\World ! ", DateAdd("s", -x, Now)
      oColorList.AddItem Chr(x Mod 26 + 1 + 65) & " \ffaa00\Hello \aaff00\colored \00aaff\World ! " & _
                                "\ffaaff\Hello \aaffff\colored \ffffaa\World ! ", DateAdd("s", -x - 1, Now)
   Next
   UpdateInfo
End Sub

Private Sub cmdChangeItem_Click()
   If Not oColorList.ListIndex = -1 Then
      oColorList.SelectedItem.ColorText = "\00ff00\Hello \ffff00\colored \ff00ff\World ! " & _
                                "\ff0ff0\Hello \0ff0ff\colored \ff0ff0\World ! "
      oColorList.SelectedItem.Tag = Now
   End If
   UpdateInfo
End Sub

Private Sub cmdClear_Click()
   oColorList.Clear
   UpdateInfo
End Sub

Private Sub cmdGoto_Click()
   Dim x As Long
   x = Val(InputBox("Goto Item Number:", "Input:"))
   If x < 0 Or x > oColorList.ListCount - 1 Then
      MsgBox "No such Item !"
   Else
      oColorList.TopIndex = x
      oColorList.ListIndex = x
   End If
   UpdateInfo
End Sub

Private Sub cmdRemove_Click()
   If Not oColorList.ListIndex = -1 Then
      oColorList.RemoveItem (oColorList.ListIndex)
   End If
   UpdateInfo
End Sub

Private Sub cmdResize_Click()
Static bSizeup As Boolean
   
   If bSizeup Then
      Me.picListbox.Width = Me.picListbox.Width * 1.25
      Me.picListbox.Height = Me.picListbox.Height * 1.25
      bSizeup = False
   Else
      Me.picListbox.Width = Me.picListbox.Width * 0.8
      Me.picListbox.Height = Me.picListbox.Height * 0.8
      bSizeup = True
   End If
End Sub

Private Sub cmdSortTag_Click()
   oColorList.Sort CListSortByTag, Not (CBool(Me.chkAscSort))
End Sub

Private Sub cmdSortText_Click()
   oColorList.Sort CListSortByText, Not (CBool(Me.chkAscSort))
End Sub


Private Sub Form_Load()
   Dim x As Integer
   
   Set oColorList = New clsColoredListbox
   oColorList.HighlightColor = Val("&haaddFF&")
   
   For x = 0 To 25 Step 2
      oColorList.AddItem Chr(x Mod 26 + 65) & " \ff0000\Hello \00ff00\colored \0000ff\World ! " & _
                                "\ff00ff\Hello \00ffff\colored \ffff00\World ! ", DateAdd("s", -x, Now)
      oColorList.AddItem Chr(x Mod 26 + 1 + 65) & " \ffaa00\Hello \aaff00\colored \00aaff\World ! " & _
                                "\ffaaff\Hello \aaffff\colored \ffffaa\World ! ", DateAdd("s", -x - 1, Now)
   Next

   oColorList.Connect Me.picListbox
   
   UpdateInfo
End Sub

Private Sub UpdateInfo()
   On Error Resume Next 'if there's no tag
   If Not oColorList.ListIndex = -1 Then
      With oColorList.SelectedItem 'or the compatible way: oColorList.List(oColorList.ListIndex)
         Me.lblSelected = "Text: " & .Text & vbCrLf & _
                          "Tag: " & .Tag & vbCrLf & _
                          "Index: " & .Index
      End With
   Else
      Me.lblSelected = ""
   End If
   Me.lblTotal = "Total Items: " & oColorList.ListCount & vbCrLf & _
                 "TopIndex: " & oColorList.TopIndex
End Sub



Private Sub picListbox_Click()
   UpdateInfo
End Sub

Private Sub picListbox_KeyUp(KeyCode As Integer, Shift As Integer)
   UpdateInfo
End Sub

